Package com.documentum.fc.client

# Interface IDfTypedObject

All Known Subinterfaces:
  `IDfACL`, `IDfAcsConfig`, `IDfActivity`, `IDfAliasSet`, `IDfAspectRelation`, `IDfAssembly`, `IDfAtmosStore`, `IDfAuditTrail`, `IDfBlobStore`, `IDfBocsConfig`, `IDfCAStore`, `IDfCollection`, `IDfContainment`, `IDfContent`, `IDfContentCollection`, `IDfContentTransferConfig`, `IDfDmsConfig`, `IDfDocbaseMap`, `IDfDocument`, `IDfDumpRecord`, `IDfExternalFileStore`, `IDfExternalStore`, `IDfFileStore`, `IDfFolder`, `IDfForeignKey`, `IDfFormat`, `IDfGroup`, `IDfLoadRecord`, `IDfLocation`, `IDfMessage`, `IDfMethodObject`, `IDfMountPoint`, `IDfNote`, `IDfPackage`, `IDfPersistentObject`, `IDfPlugin`, `IDfPolicy`, `IDfProcess`, `IDfQueueItem`, `IDfRelation`, `IDfRelationType`, `IDfRetainer`, `IDfRouter`, `IDfSearchResults`, `IDfServerMap`, `IDfSessionManagerConfig`, `IDfSmartList`, `IDfStateExtension`, `IDfStore`, `IDfSysObject`, `IDfSysObjectStream`, `IDfType`, `IDfUser`, `IDfValidationDescriptor`, `IDfWorkflow`, `IDfWorkflowAttachment`, `IDfWorkitem`, `com.documentum.fc.client.internal.IPersistentObjectInternal`, `com.documentum.fc.client.internal.ITypedObjectInternal`

All Known Implementing Classes:
  `AtmosStore`, `com.documentum.fc.client.DfPersistentObject`, `com.documentum.fc.client.DfTypedObject`, `com.documentum.fc.client.content.impl.Store`

public interface IDfTypedObject
Public operations for all typed objects.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `appendBoolean(String attributeName, boolean value)`
  Appends a boolean value to a repeating attribute.
  `void`
  `appendDouble(String attributeName, double value)`
  Appends a double value to a repeating attribute.
  `void`
  `appendId(String attributeName, IDfId value)`
  Appends an ID value to a repeating attribute.
  `void`
  `appendInt(String attributeName, int value)`
  Appends an integer value to a repeating attribute.
  `void`
  `appendString(String attributeName, String value)`
  Appends a string value to a repeating attribute.
  `void`
  `appendTime(String attributeName, IDfTime value)`
  Appends a date/time value to a repeating attribute.
  `void`
  `appendValue(String attributeName, IDfValue value)`
  Appends a value stored in an IDfValue object to a repeating attribute.
  `String`
  `dump()`
  Lists an object's attributes and their values.
  `Enumeration`
  `enumAttrs()`
  Returns an enumeration of IDfAttr objects.
  `int`
  `findAttrIndex(String attributeName)`
  Returns the position of an attribute in the list of attributes that belong to this object.
  `int`
  `findBoolean(String attributeName, boolean value)`
  Searches through the values in a repeating attribute and returns the index of the first value that matches the specified boolean value.
  `int`
  `findDouble(String attributeName, double value)`
  Searches through the values in a repeating attribute and returns the index of the first value that matches the specified double value.
  `int`
  `findId(String attributeName, IDfId value)`
  Searches through the values in a repeating attribute and returns the index of the first value that matches the specified ID value.
  `int`
  `findInt(String attributeName, int value)`
  Searches through the values in a repeating attribute and returns the index of the first value that matches the specified integer value.
  `int`
  `findString(String attributeName, String value)`
  Searches through the values in a repeating attribute and returns the index of the first value that matches the specified string value.
  `int`
  `findTime(String attributeName, IDfTime value)`
  Searches through the values in a repeating attribute and returns the index of the first value that matches the specified date/time value.
  `int`
  `findValue(String attributeName, IDfValue value)`
  Searches through the values in a repeating attribute and returns the index of the first value that matches the specified value.
  `String`
  `getAllRepeatingStrings(String attributeName, String separator)`
  Returns all the values stored in a repeating attribute as a single string.
  `IDfAttr`
  `getAttr(int attrIndex)`
  Returns an attribute description.
  `int`
  `getAttrCount()`
  Returns the number of attributes belonging to this object.
  `int`
  `getAttrDataType(String attributeName)`
  Returns the data type of an attribute.
  `boolean`
  `getBoolean(String attributeName)`
  Returns the boolean value of an attribute.
  `double`
  `getDouble(String attributeName)`
  Returns the double value of an attribute.
  `IDfId`
  `getId(String attributeName)`
  Returns the ID value of an attribute.
  `int`
  `getInt(String attributeName)`
  Returns the integer value of an attribute.
  `long`
  `getLong(String attributeName)`
  Returns the long integer value of an attribute.
  `IDfId`
  `getObjectId()`
  Returns the ID of this object.
  `IDfSession`
  `getObjectSession()`
  Gets the session to the Docbase containing the object.
  `IDfSession`
  `getOriginalSession()`
  Gets the session through which the object was originally requested.
  `boolean`
  `getRepeatingBoolean(String attributeName, int valueIndex)`
  Returns a boolean value stored in a repeating attribute.
  `double`
  `getRepeatingDouble(String attributeName, int valueIndex)`
  Returns a double value stored in a repeating attribute.
  `IDfId`
  `getRepeatingId(String attributeName, int valueIndex)`
  Returns an Object ID value stored in a repeating attribute.
  `int`
  `getRepeatingInt(String attributeName, int valueIndex)`
  Returns an integer value stored in a repeating attribute.
  `long`
  `getRepeatingLong(String attributeName, int valueIndex)`
  Returns a long integer value stored in a repeating attribute.
  `String`
  `getRepeatingString(String attributeName, int valueIndex)`
  Returns a string value stored in a repeating attribute.
  `IDfTime`
  `getRepeatingTime(String attributeName, int valueIndex)`
  Returns a date/time value stored in a repeating attribute.
  `IDfValue`
  `getRepeatingValue(String attributeName, int valueIndex)`
  Returns a value stored in a repeating attribute as an IDfValue object.
  `IDfSession`
  `getSession()`
  Gets the session through which the object was originally requested.
  `IDfSessionManager`
  `getSessionManager()`
  Returns the session manager associated with this object.
  `String`
  `getString(String attributeName)`
  Returns the string value of an attribute.
  `IDfTime`
  `getTime(String attributeName)`
  Returns the date/time value of an attribute.
  `IDfValue`
  `getValue(String attributeName)`
  Returns the value of an attribute asn an IDfValue object.
  `IDfValue`
  `getValueAt(int index)`
  Returns the value stored in the attribute at the specified attribute index.
  `int`
  `getValueCount(String attributeName)`
  Returns the number of values stored in an attribute.
  `boolean`
  `hasAttr(String attributeName)`
  Indicates whether an attribute exists for this object.
  `void`
  `insertBoolean(String attributeName, int valueIndex, boolean value)`
  Inserts a boolean value into a repeating attribute.
  `void`
  `insertDouble(String attributeName, int valueIndex, double value)`
  Inserts a double value into a repeating attribute.
  `void`
  `insertId(String attributeName, int valueIndex, IDfId value)`
  Inserts an Object ID value into a repeating attribute.
  `void`
  `insertInt(String attributeName, int valueIndex, int value)`
  Inserts an integer value into a repeating attribute.
  `void`
  `insertString(String attributeName, int valueIndex, String value)`
  Inserts a string value into a repeating attribute.
  `void`
  `insertTime(String attributeName, int valueIndex, IDfTime value)`
  Inserts a date/time value into a repeating attribute.
  `void`
  `insertValue(String attributeName, int valueIndex, IDfValue value)`
  Inserts a variant value into a repeating attribute.
  `boolean`
  `isAttrRepeating(String attributeName)`
  Indicates whether an attribute is a repeating attribute.
  `boolean`
  `isNull(String attributeName)`
  Reserved for future use.
  `void`
  `remove(String attributeName, int valueIndex)`
  Removes a value stored in a repeating attribute.
  `void`
  `removeAll(String attributeName)`
  Removes all values stored in a repeating attribute.
  `void`
  `setBoolean(String attributeName, boolean value)`
  Sets the boolean value of an attribute.
  `void`
  `setDouble(String attributeName, double value)`
  Sets the double value of an attribute.
  `void`
  `setId(String attributeName, IDfId value)`
  Sets the Object ID value of an attribute.
  `void`
  `setInt(String attributeName, int value)`
  Sets the integer value of an attribute.
  `void`
  `setNull(String attributeName)`
  Reserved for future use.
  `void`
  `setRepeatingBoolean(String attributeName, int valueIndex, boolean value)`
  Sets a boolean value of a repeating attribute.
  `void`
  `setRepeatingDouble(String attributeName, int valueIndex, double value)`
  Sets a double value of a repeating attribute.
  `void`
  `setRepeatingId(String attributeName, int valueIndex, IDfId value)`
  Sets a Object ID value of a repeating attribute.
  `void`
  `setRepeatingInt(String attributeName, int valueIndex, int value)`
  Sets an integer value of a repeating attribute.
  `void`
  `setRepeatingString(String attributeName, int valueIndex, String value)`
  Sets a string value of a repeating attribute.
  `void`
  `setRepeatingTime(String attributeName, int valueIndex, IDfTime value)`
  Sets a date/time value of a repeating attribute.
  `void`
  `setRepeatingValue(String attributeName, int valueIndex, IDfValue value)`
  Sets a value of a repeating attribute.
  `void`
  `setSessionManager(IDfSessionManager sessMgr)`
  Associates a session manager with this object.
  `void`
  `setString(String attributeName, String value)`
  Sets the string value of an attribute.
  `void`
  `setTime(String attributeName, IDfTime value)`
  Sets the date/time value of an attribute.
  `void`
  `setValue(String attributeName, IDfValue value)`
  Sets the value of an attribute.
  `void`
  `truncate(String attributeName, int valueIndex)`
  Truncates the values stored in a repeating attribute.

- ## Method Details

  - ### appendBoolean

    void appendBoolean(String attributeName, boolean value) throws DfException
    Appends a boolean value to a repeating attribute.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the boolean value that you want to append
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `appendDouble(java.lang.String, double)`
      - `appendId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `appendInt(java.lang.String, int)`
      - `appendString(java.lang.String, java.lang.String)`
      - `appendTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `appendValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### appendDouble

    void appendDouble(String attributeName, double value) throws DfException
    Appends a double value to a repeating attribute.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the double value that you want to append
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `appendBoolean(java.lang.String, boolean)`
      - `appendId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `appendInt(java.lang.String, int)`
      - `appendString(java.lang.String, java.lang.String)`
      - `appendTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `appendValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### appendId

    void appendId(String attributeName, IDfId value) throws DfException
    Appends an ID value to a repeating attribute.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the object ID that you want to append
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `appendBoolean(java.lang.String, boolean)`
      - `appendDouble(java.lang.String, double)`
      - `appendInt(java.lang.String, int)`
      - `appendString(java.lang.String, java.lang.String)`
      - `appendTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `appendValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### appendInt

    void appendInt(String attributeName, int value) throws DfException
    Appends an integer value to a repeating attribute.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the integer value that you want to append
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `appendBoolean(java.lang.String, boolean)`
      - `appendDouble(java.lang.String, double)`
      - `appendId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `appendString(java.lang.String, java.lang.String)`
      - `appendTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `appendValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### appendString

    void appendString(String attributeName, String value) throws DfException
    Appends a string value to a repeating attribute.
    Parameters:
      `attributeName` - the name of the attribute to which you want to append a string value
      `value` - the string value that you want to append
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `appendBoolean(java.lang.String, boolean)`
      - `appendDouble(java.lang.String, double)`
      - `appendId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `appendInt(java.lang.String, int)`
      - `appendTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `appendValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### appendTime

    void appendTime(String attributeName, IDfTime value) throws DfException
    Appends a date/time value to a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the time value that you want to append
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `appendBoolean(java.lang.String, boolean)`
      - `appendDouble(java.lang.String, double)`
      - `appendId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `appendInt(java.lang.String, int)`
      - `appendString(java.lang.String, java.lang.String)`
      - `appendValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### appendValue

    void appendValue(String attributeName, IDfValue value) throws DfException
    Appends a value stored in an IDfValue object to a repeating attribute.

    The IDfValue datatype acts as a variant that can store any of the Documentum types. The Value object created to store the variant value is immutable (its value cannot be changed).
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the variant value that you want to append
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `appendBoolean(java.lang.String, boolean)`
      - `appendDouble(java.lang.String, double)`
      - `appendId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `appendInt(java.lang.String, int)`
      - `appendString(java.lang.String, java.lang.String)`
      - `appendTime(java.lang.String, com.documentum.fc.common.IDfTime)`

  - ### dump

    String dump() throws DfException
    Lists an object's attributes and their values.

    This method is primarily intended for debugging purposes. `dump` arranges the returned data in three categories: User Attributes, System Attributes, and Application Attributes.
    Returns:
      a string containing the object's attributes and their values
    Throws:
      `DfException` - if a server error occurs

  - ### enumAttrs

    Enumeration enumAttrs() throws DfException
    Returns an enumeration of IDfAttr objects.

    The enumeration interface is Java-specific. If you are programming with COM, you need to do one of the following:

    A. Call the methods of the Enumerator interface through IDispatch.
    The following sample code demonstrates option A in Visual Basic.

         Object o = my_object.enumAttrs()
         Dim attr as IDfAttr
         While o.hasMoreElements = true
         Set attr = o.nextElement
         name$ = attr.getName
         Wend

    B. Convert the interface to a IDfEnumeration interface by passing the enumeration interface to the getEnumeration() method in IDfClientX.
    The following sample code demonstrates option B in Visual Basic.

         Object o = my_object.enumAttrs()
         Dim en As IDfEnumeration
         Dim attr as IDfAttr
         Set en = clientx.getEnumeration(o)
         While en.hasMoreElements = true
         Set attr = en.nextElement
         name$ = attr.getName
         Wend

    Returns:
      an Enumeration interface to all the attributes of the object
    Throws:
      `DfException` - if a server error occurs

  - ### findAttrIndex

    int findAttrIndex(String attributeName) throws DfException
    Returns the position of an attribute in the list of attributes that belong to this object.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the index of the attribute in the object's list of attributes
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getAttr(int)`

  - ### findBoolean

    int findBoolean(String attributeName, boolean value) throws DfException
    Searches through the values in a repeating attribute and returns the index of the first value that matches the specified boolean value.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the boolean value to locate
    Returns:
      index the index of the value or -1 if the value can't be found.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findDouble(java.lang.String, double)`
      - `findId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `findInt(java.lang.String, int)`
      - `findString(java.lang.String, java.lang.String)`
      - `findTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `findValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### findDouble

    int findDouble(String attributeName, double value) throws DfException
    Searches through the values in a repeating attribute and returns the index of the first value that matches the specified double value.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the double value to locate
    Returns:
      index the index of the value or -1 if the value can't be found.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findBoolean(java.lang.String, boolean)`
      - `findId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `findInt(java.lang.String, int)`
      - `findString(java.lang.String, java.lang.String)`
      - `findTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `findValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### findId

    int findId(String attributeName, IDfId value) throws DfException
    Searches through the values in a repeating attribute and returns the index of the first value that matches the specified ID value.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the object ID to locate
    Returns:
      index the index of the value or -1 if the value can't be found.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findBoolean(java.lang.String, boolean)`
      - `findDouble(java.lang.String, double)`
      - `findInt(java.lang.String, int)`
      - `findString(java.lang.String, java.lang.String)`
      - `findTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `findValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### findInt

    int findInt(String attributeName, int value) throws DfException
    Searches through the values in a repeating attribute and returns the index of the first value that matches the specified integer value.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the integer value to locate
    Returns:
      index the index of the value or -1 if the value can't be found.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findBoolean(java.lang.String, boolean)`
      - `findDouble(java.lang.String, double)`
      - `findId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `findString(java.lang.String, java.lang.String)`
      - `findTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `findValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### findString

    int findString(String attributeName, String value) throws DfException
    Searches through the values in a repeating attribute and returns the index of the first value that matches the specified string value.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the string value to locate
    Returns:
      index the index of the value or -1 if the value can't be found.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findBoolean(java.lang.String, boolean)`
      - `findDouble(java.lang.String, double)`
      - `findId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `findInt(java.lang.String, int)`
      - `findTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `findValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### findTime

    int findTime(String attributeName, IDfTime value) throws DfException
    Searches through the values in a repeating attribute and returns the index of the first value that matches the specified date/time value.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the time value to locate
    Returns:
      index the index of the value or -1 if the value can't be found.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findBoolean(java.lang.String, boolean)`
      - `findDouble(java.lang.String, double)`
      - `findId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `findInt(java.lang.String, int)`
      - `findString(java.lang.String, java.lang.String)`
      - `findValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### findValue

    int findValue(String attributeName, IDfValue value) throws DfException
    Searches through the values in a repeating attribute and returns the index of the first value that matches the specified value.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `value` - the variant value to locate
    Returns:
      index the index of the value or -1 if the value can't be found.
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findBoolean(java.lang.String, boolean)`
      - `findDouble(java.lang.String, double)`
      - `findId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `findInt(java.lang.String, int)`
      - `findString(java.lang.String, java.lang.String)`
      - `findTime(java.lang.String, com.documentum.fc.common.IDfTime)`

  - ### getAllRepeatingStrings

    String getAllRepeatingStrings(String attributeName, String separator) throws DfException
    Returns all the values stored in a repeating attribute as a single string.

    The values are delimited with the string passed as the `separator` argument.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `separator` - the symbol that you want used to separate the retrieved values of the repeating attribute. The symbol can only be a single character. If you specify `null` as the separator, a comma will be used to separate the returned values.
    Returns:
      all values stored in the repeating attribute as a single delimited string
    Throws:
      `DfException` - if a server error occurs

  - ### getAttr

    IDfAttr getAttr(int attrIndex) throws DfException
    Returns an attribute description.
    Parameters:
      `attrIndex` - the index position of the attribute among the object's types
    Returns:
      an IDfAttr interface to the attribute
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findAttrIndex(java.lang.String)`

  - ### getAttrCount

    int getAttrCount() throws DfException
    Returns the number of attributes belonging to this object.
    Returns:
      the number of attributes belonging to the calling object
    Throws:
      `DfException` - if a server error occurs

  - ### getAttrDataType

    int getAttrDataType(String attributeName) throws DfException
    Returns the data type of an attribute.

    Note: If this method is used on an instance of IDfCollection then it can return unexpected values. The datatype it returns for an attribute that is part of a query collection is the type that Content Server returns. This may differ from the datatype that the IDfSysObject interface specifies for that attribute. The type returned may vary with the server’s underlying relational database. Workaround: Structure your application in such a way that you do not need to invoke this method.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the data type of the attribute
    Throws:
      `DfException` - if a server error occurs

  - ### getBoolean

    boolean getBoolean(String attributeName) throws DfException
    Returns the boolean value of an attribute.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, `false` is returned.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the boolean value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getDouble(java.lang.String)`
      - `getId(java.lang.String)`
      - `getInt(java.lang.String)`
      - `getString(java.lang.String)`
      - `getTime(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getDouble

    double getDouble(String attributeName) throws DfException
    Returns the double value of an attribute.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, `0.0` is returned.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the double value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getBoolean(java.lang.String)`
      - `getId(java.lang.String)`
      - `getInt(java.lang.String)`
      - `getString(java.lang.String)`
      - `getTime(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getId

    IDfId getId(String attributeName) throws DfException
    Returns the ID value of an attribute.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, `DfId.DF_nullID` is returned.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      an IDfId interface to the object ID
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getBoolean(java.lang.String)`
      - `getDouble(java.lang.String)`
      - `getInt(java.lang.String)`
      - `getString(java.lang.String)`
      - `getTime(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getInt

    int getInt(String attributeName) throws DfException
    Returns the integer value of an attribute.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, `0` is returned.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the integer value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getBoolean(java.lang.String)`
      - `getDouble(java.lang.String)`
      - `getId(java.lang.String)`
      - `getString(java.lang.String)`
      - `getTime(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getLong

    long getLong(String attributeName) throws DfException
    Returns the long integer value of an attribute.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, `0` is returned.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the long integer value
    Throws:
      `DfException` - if a server error occurs
    Since:
      5.1
    See Also:
      - `getBoolean(java.lang.String)`
      - `getDouble(java.lang.String)`
      - `getId(java.lang.String)`
      - `getString(java.lang.String)`
      - `getTime(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getObjectId

    IDfId getObjectId() throws DfException
    Returns the ID of this object.
    Returns:
      an IDfId interface to the object ID
    Throws:
      `DfException` - if an error occurs

  - ### getRepeatingBoolean

    boolean getRepeatingBoolean(String attributeName, int valueIndex) throws DfException
    Returns a boolean value stored in a repeating attribute.

    You can call this method on a single-valued attribute as long as `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the desired boolean value
    Returns:
      the boolean value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getRepeatingDouble(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingString(java.lang.String, int)`
      - `getRepeatingTime(java.lang.String, int)`
      - `getRepeatingValue(java.lang.String, int)`

  - ### getRepeatingDouble

    double getRepeatingDouble(String attributeName, int valueIndex) throws DfException
    Returns a double value stored in a repeating attribute.

    You can call this method on a single-valued attribute as long as `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the value among the values stored in the repeating attribute
    Returns:
      the double value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getRepeatingBoolean(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingString(java.lang.String, int)`
      - `getRepeatingTime(java.lang.String, int)`
      - `getRepeatingValue(java.lang.String, int)`

  - ### getRepeatingId

    IDfId getRepeatingId(String attributeName, int valueIndex) throws DfException
    Returns an Object ID value stored in a repeating attribute.

    You can call this method on a single-valued attribute as long as `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the value among the values stored in the repeating attribute
    Returns:
      an IDfId interface to the object ID
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getRepeatingBoolean(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingString(java.lang.String, int)`
      - `getRepeatingTime(java.lang.String, int)`
      - `getRepeatingValue(java.lang.String, int)`

  - ### getRepeatingInt

    int getRepeatingInt(String attributeName, int valueIndex) throws DfException
    Returns an integer value stored in a repeating attribute.

    You can call this method on a single-valued attribute as long as `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the value among the values stored in the repeating attribute
    Returns:
      the integer value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getRepeatingBoolean(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingString(java.lang.String, int)`
      - `getRepeatingTime(java.lang.String, int)`
      - `getRepeatingValue(java.lang.String, int)`

  - ### getRepeatingLong

    long getRepeatingLong(String attributeName, int valueIndex) throws DfException
    Returns a long integer value stored in a repeating attribute.

    You can call this method on a single-valued attribute as long as `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the value among the values stored in the repeating attribute
    Returns:
      the long integer value
    Throws:
      `DfException` - if a server error occurs
    Since:
      5.1
    See Also:
      - `getRepeatingBoolean(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingString(java.lang.String, int)`
      - `getRepeatingTime(java.lang.String, int)`
      - `getRepeatingValue(java.lang.String, int)`

  - ### getRepeatingString

    String getRepeatingString(String attributeName, int valueIndex) throws DfException
    Returns a string value stored in a repeating attribute.

    You can call this method on a single-valued attribute as long as `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the value among the values stored in the repeating attribute
    Returns:
      the string value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getRepeatingBoolean(java.lang.String, int)`
      - `getRepeatingDouble(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingTime(java.lang.String, int)`
      - `getRepeatingValue(java.lang.String, int)`

  - ### getRepeatingTime

    IDfTime getRepeatingTime(String attributeName, int valueIndex) throws DfException
    Returns a date/time value stored in a repeating attribute.

    You can call this method on a single-valued attribute as long as `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the value among the values stored in the repeating attribute
    Returns:
      an IDfTime interface to the time value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getRepeatingBoolean(java.lang.String, int)`
      - `getRepeatingDouble(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingString(java.lang.String, int)`
      - `getRepeatingValue(java.lang.String, int)`

  - ### getRepeatingValue

    IDfValue getRepeatingValue(String attributeName, int valueIndex) throws DfException
    Returns a value stored in a repeating attribute as an IDfValue object.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -2 for `valueIndex` will return the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position of the value among the values stored in the repeating attribute
    Returns:
      an IDfValue interface to the variant value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getRepeatingBoolean(java.lang.String, int)`
      - `getRepeatingDouble(java.lang.String, int)`
      - `getRepeatingId(java.lang.String, int)`
      - `getRepeatingInt(java.lang.String, int)`
      - `getRepeatingString(java.lang.String, int)`
      - `getRepeatingTime(java.lang.String, int)`

  - ### getObjectSession

    IDfSession getObjectSession()
    Gets the session to the Docbase containing the object.

    This is the session that is used for most object operations because it the session which has direct access to the object data.
    Returns:
      a session to the Docbase containing the object
    See Also:
      - `getOriginalSession()`

  - ### getOriginalSession

    IDfSession getOriginalSession()
    Gets the session through which the object was originally requested.

    The original session is typically used for operations that require access to the original Docbase scope from which the object was requested (This can be different than the Docbase in which the object resides).
    Returns:
      the session through which the object was originally requested
    See Also:
      - `getObjectSession()`

  - ### getSession

    IDfSession getSession()
    Gets the session through which the object was originally requested.

    This is the same as `getOriginalSession()`
    Returns:
      the session on which the object was originally obtained

  - ### getSessionManager

    IDfSessionManager getSessionManager()
    Returns the session manager associated with this object.
    Returns:
      an IDfSessionManager interface to the session manager
    Since:
      5.1
    See Also:
      - `setSessionManager(com.documentum.fc.client.IDfSessionManager)`
      - `IDfSessionManager`

  - ### getString

    String getString(String attributeName) throws DfException
    Returns the string value of an attribute.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, null is returned
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the string value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getBoolean(java.lang.String)`
      - `getDouble(java.lang.String)`
      - `getId(java.lang.String)`
      - `getInt(java.lang.String)`
      - `getTime(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getTime

    IDfTime getTime(String attributeName) throws DfException
    Returns the date/time value of an attribute.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, `DfTime.DF_nullDATE` is returned.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      an IDfTime interface to the time value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getBoolean(java.lang.String)`
      - `getDouble(java.lang.String)`
      - `getId(java.lang.String)`
      - `getInt(java.lang.String)`
      - `getString(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getValue

    IDfValue getValue(String attributeName) throws DfException
    Returns the value of an attribute asn an IDfValue object.

    If the attribute `attributeName` is a repeating attribute, the value at index 0 is returned. If `attributeName` is a repeating attribute without any values, `false` is returned.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      an IDfValue interface to the variant value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getBoolean(java.lang.String)`
      - `getDouble(java.lang.String)`
      - `getId(java.lang.String)`
      - `getInt(java.lang.String)`
      - `getString(java.lang.String)`
      - `getTime(java.lang.String)`

  - ### getValueAt

    IDfValue getValueAt(int index) throws DfException
    Returns the value stored in the attribute at the specified attribute index.

    If the attribute at this index is a repeating attribute, the value at the value-index 0 is returned.
    Parameters:
      `index` - the index of the attribute
    Returns:
      an IDfValue interface to the variant value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `getBoolean(java.lang.String)`
      - `getDouble(java.lang.String)`
      - `getId(java.lang.String)`
      - `getInt(java.lang.String)`
      - `getString(java.lang.String)`
      - `getTime(java.lang.String)`
      - `getValue(java.lang.String)`

  - ### getValueCount

    int getValueCount(String attributeName) throws DfException
    Returns the number of values stored in an attribute.

    This will always return 1 for single-valued attributes, and return a non-negative number for repeating attributes.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      the number of values stored in the attribute
    Throws:
      `DfException` - if a server error occurs

  - ### hasAttr

    boolean hasAttr(String attributeName) throws DfException
    Indicates whether an attribute exists for this object.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      `true` if the specified attribute exists; `false` if it does not.
    Throws:
      `DfException` - if a server error occurs

  - ### insertBoolean

    void insertBoolean(String attributeName, int valueIndex, boolean value) throws DfException
    Inserts a boolean value into a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to insert the boolean value
      `value` - the boolean value that you want to insert
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `insertDouble(java.lang.String, int, double)`
      - `insertId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `insertInt(java.lang.String, int, int)`
      - `insertString(java.lang.String, int, java.lang.String)`
      - `insertTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `insertValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### insertDouble

    void insertDouble(String attributeName, int valueIndex, double value) throws DfException
    Inserts a double value into a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to insert a double value
      `value` - the double value that you want to insert
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `insertBoolean(java.lang.String, int, boolean)`
      - `insertId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `insertInt(java.lang.String, int, int)`
      - `insertString(java.lang.String, int, java.lang.String)`
      - `insertTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `insertValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### insertId

    void insertId(String attributeName, int valueIndex, IDfId value) throws DfException
    Inserts an Object ID value into a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to insert the object ID
      `value` - the object ID that you want to insert
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `insertBoolean(java.lang.String, int, boolean)`
      - `insertDouble(java.lang.String, int, double)`
      - `insertInt(java.lang.String, int, int)`
      - `insertString(java.lang.String, int, java.lang.String)`
      - `insertTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `insertValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### insertInt

    void insertInt(String attributeName, int valueIndex, int value) throws DfException
    Inserts an integer value into a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to insert the integer value
      `value` - the integer value that you want to insert
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `insertBoolean(java.lang.String, int, boolean)`
      - `insertDouble(java.lang.String, int, double)`
      - `insertId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `insertString(java.lang.String, int, java.lang.String)`
      - `insertTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `insertValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### insertString

    void insertString(String attributeName, int valueIndex, String value) throws DfException
    Inserts a string value into a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to insert the string value
      `value` - the string value that you want to insert
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `insertBoolean(java.lang.String, int, boolean)`
      - `insertDouble(java.lang.String, int, double)`
      - `insertId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `insertInt(java.lang.String, int, int)`
      - `insertTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `insertValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### insertTime

    void insertTime(String attributeName, int valueIndex, IDfTime value) throws DfException
    Inserts a date/time value into a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to insert the time value
      `value` - the time value that you want to insert
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `insertBoolean(java.lang.String, int, boolean)`
      - `insertDouble(java.lang.String, int, double)`
      - `insertId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `insertInt(java.lang.String, int, int)`
      - `insertString(java.lang.String, int, java.lang.String)`
      - `insertValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### insertValue

    void insertValue(String attributeName, int valueIndex, IDfValue value) throws DfException
    Inserts a variant value into a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to insert the variant value
      `value` - the variant value that you want to insert
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `insertBoolean(java.lang.String, int, boolean)`
      - `insertDouble(java.lang.String, int, double)`
      - `insertId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `insertInt(java.lang.String, int, int)`
      - `insertString(java.lang.String, int, java.lang.String)`
      - `insertTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`

  - ### isAttrRepeating

    boolean isAttrRepeating(String attributeName) throws DfException
    Indicates whether an attribute is a repeating attribute.
    Parameters:
      `attributeName` - the name of the attribute
    Returns:
      `true` if the attribute is repeating; `false` if it is not.
    Throws:
      `DfException` - if a server error occurs

  - ### isNull

    boolean isNull(String attributeName) throws DfException
    Reserved for future use.
    Parameters:
      `attributeName` - the name of the attribute
    Throws:
      `DfException` - if a server error occurs

  - ### remove

    void remove(String attributeName, int valueIndex) throws DfException
    Removes a value stored in a repeating attribute.

    The remaining rows in the attribute are renumbered. Do not use this method to remove tasks from a router.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to remove a value
    Throws:
      `DfException` - if a server error occurs

  - ### removeAll

    void removeAll(String attributeName) throws DfException
    Removes all values stored in a repeating attribute.
    Parameters:
      `attributeName` - the name of the repeating attribute
    Throws:
      `DfException` - if a server error occurs

  - ### setBoolean

    void setBoolean(String attributeName, boolean value) throws DfException
    Sets the boolean value of an attribute.

    If the attribute is a repeating attribute, this will set the value at index 0.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the boolean value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setDouble(java.lang.String, double)`
      - `setId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `setInt(java.lang.String, int)`
      - `setString(java.lang.String, java.lang.String)`
      - `setTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `setValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### setDouble

    void setDouble(String attributeName, double value) throws DfException
    Sets the double value of an attribute.

    If the attribute is a repeating attribute, this will set the value at index 0.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the double value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setBoolean(java.lang.String, boolean)`
      - `setId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `setInt(java.lang.String, int)`
      - `setString(java.lang.String, java.lang.String)`
      - `setTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `setValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### setId

    void setId(String attributeName, IDfId value) throws DfException
    Sets the Object ID value of an attribute.

    If the attribute is a repeating attribute, this will set the value at index 0.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - an IDfId interface to the object ID
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setBoolean(java.lang.String, boolean)`
      - `setDouble(java.lang.String, double)`
      - `setInt(java.lang.String, int)`
      - `setString(java.lang.String, java.lang.String)`
      - `setTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `setValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### setInt

    void setInt(String attributeName, int value) throws DfException
    Sets the integer value of an attribute.

    If the attribute is a repeating attribute, this will set the value at index 0.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the integer value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setBoolean(java.lang.String, boolean)`
      - `setDouble(java.lang.String, double)`
      - `setId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `setString(java.lang.String, java.lang.String)`
      - `setTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `setValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### setNull

    void setNull(String attributeName) throws DfException
    Reserved for future use.
    Parameters:
      `attributeName` - the name of the attribute
    Throws:
      `DfException` - if a server error occurs

  - ### setRepeatingBoolean

    void setRepeatingBoolean(String attributeName, int valueIndex, boolean value) throws DfException
    Sets a boolean value of a repeating attribute.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -1 for `valueIndex` will set the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to assign the boolean value
      `value` - the boolean value that you want to assign
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setRepeatingDouble(java.lang.String, int, double)`
      - `setRepeatingId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `setRepeatingInt(java.lang.String, int, int)`
      - `setRepeatingString(java.lang.String, int, java.lang.String)`
      - `setRepeatingTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `setRepeatingValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### setRepeatingDouble

    void setRepeatingDouble(String attributeName, int valueIndex, double value) throws DfException
    Sets a double value of a repeating attribute.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -1 for `valueIndex` will set the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to assign a double value
      `value` - the double value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setRepeatingBoolean(java.lang.String, int, boolean)`
      - `setRepeatingId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `setRepeatingInt(java.lang.String, int, int)`
      - `setRepeatingString(java.lang.String, int, java.lang.String)`
      - `setRepeatingTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `setRepeatingValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### setRepeatingId

    void setRepeatingId(String attributeName, int valueIndex, IDfId value) throws DfException
    Sets a Object ID value of a repeating attribute.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -1 for `valueIndex` will set the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to assign an object ID
      `value` - the object ID
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setRepeatingBoolean(java.lang.String, int, boolean)`
      - `setRepeatingDouble(java.lang.String, int, double)`
      - `setRepeatingInt(java.lang.String, int, int)`
      - `setRepeatingString(java.lang.String, int, java.lang.String)`
      - `setRepeatingTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `setRepeatingValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### setRepeatingInt

    void setRepeatingInt(String attributeName, int valueIndex, int value) throws DfException
    Sets an integer value of a repeating attribute.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -1 for `valueIndex` will set the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to assign an integer value
      `value` - the integer value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setRepeatingBoolean(java.lang.String, int, boolean)`
      - `setRepeatingDouble(java.lang.String, int, double)`
      - `setRepeatingId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `setRepeatingString(java.lang.String, int, java.lang.String)`
      - `setRepeatingTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `setRepeatingValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### setRepeatingString

    void setRepeatingString(String attributeName, int valueIndex, String value) throws DfException
    Sets a string value of a repeating attribute.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -1 for `valueIndex` will set the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to assign a string value
      `value` - the string value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setRepeatingBoolean(java.lang.String, int, boolean)`
      - `setRepeatingDouble(java.lang.String, int, double)`
      - `setRepeatingId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `setRepeatingInt(java.lang.String, int, int)`
      - `setRepeatingTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`
      - `setRepeatingValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### setRepeatingTime

    void setRepeatingTime(String attributeName, int valueIndex, IDfTime value) throws DfException
    Sets a date/time value of a repeating attribute.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -1 for `valueIndex` will set the value at index 0.
    Parameters:
      `attributeName` - The name of the repeating attribute
      `valueIndex` - The index position where you want to assign a time value
      `value` - The time value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setRepeatingBoolean(java.lang.String, int, boolean)`
      - `setRepeatingDouble(java.lang.String, int, double)`
      - `setRepeatingId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `setRepeatingInt(java.lang.String, int, int)`
      - `setRepeatingString(java.lang.String, int, java.lang.String)`
      - `setRepeatingValue(java.lang.String, int, com.documentum.fc.common.IDfValue)`

  - ### setRepeatingValue

    void setRepeatingValue(String attributeName, int valueIndex, IDfValue value) throws DfException
    Sets a value of a repeating attribute.

    You can call this method on a single-valued attribute as long as the `valueIndex` is 0. Note that negative values are interpreted as 0. For example, passing -1 for `valueIndex` will set the value at index 0.
    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where you want to assign a variant value
      `value` - the variant value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setRepeatingBoolean(java.lang.String, int, boolean)`
      - `setRepeatingDouble(java.lang.String, int, double)`
      - `setRepeatingId(java.lang.String, int, com.documentum.fc.common.IDfId)`
      - `setRepeatingInt(java.lang.String, int, int)`
      - `setRepeatingString(java.lang.String, int, java.lang.String)`
      - `setRepeatingTime(java.lang.String, int, com.documentum.fc.common.IDfTime)`

  - ### setSessionManager

    void setSessionManager(IDfSessionManager sessMgr) throws DfException
    Associates a session manager with this object.
    Parameters:
      `sessMgr` -
    Throws:
      `DfException`
    Since:
      5.1
    See Also:
      - `getSessionManager()`
      - `IDfSessionManager`
      - `IDfSessionManager.beginClientControl()`
      - `IDfSessionManager.beginTransaction()`

  - ### setString

    void setString(String attributeName, String value) throws DfException
    Sets the string value of an attribute.

    If the attribute is a repeating attribute, this will set the value at index 0.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the string value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setBoolean(java.lang.String, boolean)`
      - `setDouble(java.lang.String, double)`
      - `setId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `setInt(java.lang.String, int)`
      - `setTime(java.lang.String, com.documentum.fc.common.IDfTime)`
      - `setValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### setTime

    void setTime(String attributeName, IDfTime value) throws DfException
    Sets the date/time value of an attribute.

    If the attribute is a repeating attribute, this will set the value at index 0.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - the time value
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setBoolean(java.lang.String, boolean)`
      - `setDouble(java.lang.String, double)`
      - `setId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `setInt(java.lang.String, int)`
      - `setString(java.lang.String, java.lang.String)`
      - `setValue(java.lang.String, com.documentum.fc.common.IDfValue)`

  - ### setValue

    void setValue(String attributeName, IDfValue value) throws DfException
    Sets the value of an attribute.

    If the attribute is a repeating attribute, this will set the value at index 0.
    Parameters:
      `attributeName` - the name of the attribute
      `value` - an IDfValue value containing the value that you want to assign to this attribute
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `setBoolean(java.lang.String, boolean)`
      - `setDouble(java.lang.String, double)`
      - `setId(java.lang.String, com.documentum.fc.common.IDfId)`
      - `setInt(java.lang.String, int)`
      - `setString(java.lang.String, java.lang.String)`
      - `setTime(java.lang.String, com.documentum.fc.common.IDfTime)`

  - ### truncate

    void truncate(String attributeName, int valueIndex) throws DfException
    Truncates the values stored in a repeating attribute.

    The following example demonstrates how the truncate method works:

    The `cities` attribute contains the following values:

         [0] New York
         [1] Bombay
         [2] Paris
         [3] Tokyo

    If you call `my_object.truncate(cities, 2)`, the `cities` attribute contains the following values:

         [0] New York
         [1] Bombay

    Parameters:
      `attributeName` - the name of the repeating attribute
      `valueIndex` - the index position where the truncation of values begins. All values stored at this index and above will be removed
    Throws:
      `DfException` - if a server error occurs